<?php
/**
 *
 * @author            alain91
 * @copyright      (C) 2009 Alain Gandon
 * @email              alain091@gmail.com
 * @license           GPL Version 2
 */

defined('PATH_TO_ROOT') or define('PATH_TO_ROOT','..');

require_once(PATH_TO_ROOT.'/kernel/begin.php');
require_once(PATH_TO_ROOT.'/smallads/smallads_begin.php');
require_once(PATH_TO_ROOT.'/smallads/smallads.class.php');
require_once(PATH_TO_ROOT.'/smallads/smallads_interface.class.php');
require_once(PATH_TO_ROOT.'/kernel/header.php');

import('io/filesystem/folder');

if ( !$User->check_level(ADMIN_LEVEL) )
{
	$Errorh->handler('e_auth', E_USER_REDIRECT);
	Exit;
}

echo 'Debut de la mise  jour de la BDD<br>';

$module_name = 'smallads';

//Rcupration des infos de config.
$info_module = load_ini_file('../' . $module_name . '/lang/', get_ulang());

		//Rcupration de l'ancienne version du module
		$previous_version = $Sql->query("SELECT version FROM " . DB_TABLE_MODULES . " WHERE name = '".$module_name."'", __LINE__, __FILE__);


//Rcupration des fichiers de mises  jour des diffrentes versions.
$filesupdate = array();
$dir_db = '../'.$module_name.'/db/' . get_ulang() . '/';
$folder_path = new Folder($dir_db);
foreach ($folder_path->get_files('`.*\.(php|sql)$`i') as $file)
{
	$fname = $file->get_name();
	if (strpos($fname, DBTYPE) !== false)
	{
		$array_info = explode('_', $fname);
		if (isset($array_info[1]))
		{
			if (version_compare($info_module['version'], $array_info[1], '>=') && version_compare($previous_version, $array_info[1], '<'))
				$filesupdate[$array_info[1]] = $fname;
		}
	}
}

//Tri du tableau par odre des mises  jour.
uksort($filesupdate, 'version_compare');

//Execution des fichiers de mise  jour.
foreach ($filesupdate as $key => $module_update_name)
{
	if ( strpos($module_update_name, '.php') !== false ) //Parsage fichier php.
		include_once($dir_db . $module_update_name);
	elseif ( strpos($module_update_name, '.sql') !== false  ) //Requtes sql de mise  jour.
		$Sql->parse($dir_db . $module_update_name, PREFIX);
}

//Rgnration du cache du module si il l'utilise
$Cache->generate_module_file($module_name, NO_FATAL_ERROR_CACHE);

//Insertion du modules dans la bdd => module mis  jour.
$Sql->query_inject("UPDATE " . DB_TABLE_MODULES . " SET version = '" . $info_module['version'] . "' WHERE name = '" . $module_name . "'", __LINE__, __FILE__);

//Gnration du cache des modules
$Cache->Generate_file('modules');
$Cache->Generate_file('menus');
$Cache->Generate_file('css');

//Mise  jour du .htaccess pour le mod rewrite, si il est actif et que le module le supporte
if ($CONFIG['rewrite'] == 1 && !empty($info_module['url_rewrite']))
	$Cache->Generate_file('htaccess'); //Rgnration du htaccess.

echo 'Fin de la mise  jour de la BDD';
?>